require 'dry/importer/version'

module Dry
  module Importer
    module_function

    WRAPPER_MAP = {
      Class  => ->(const) { Class.new(const) },
      Module => ->(const) { Module.new.extend(const) }
    }
    NOOP = ->(const) { const }

    def import(target, namespace)
      namespace.constants(false).each do |constant|
        namespace.const_get(constant).tap do |const|
          ns = target.const_set(constant, WRAPPER_MAP.fetch(const.class, NOOP).call(const))
          import(ns, const) if const.respond_to?(:constants)
        end
      end
    end
  end
end
